summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--AUTHORS7
-rw-r--r--README3
-rw-r--r--docs/examples/tunnel-he-ipv611
-rw-r--r--docs/netcfg-profiles.txt16
-rw-r--r--src/connections/bond49
-rw-r--r--src/connections/tunnel41
6 files changed, 127 insertions, 0 deletions
diff --git a/AUTHORS b/AUTHORS
new file mode 100644
index 0000000..3ca9188
--- /dev/null
+++ b/AUTHORS
@@ -0,0 +1,7 @@
+James Rayner <james@archlinux.org>
+Jim Pryor <profjim@jimpryor.net>
+Kyle Fuller <inbox@kylefuller.co.uk>
+Andrea Scarpino <andrea@archlinux.org>
+Thomas Bächler <thomas@archlinux.org>
+Rémy Oudompheng <remy@archlinux.org>
+
diff --git a/README b/README
index f0b9863..5839ee3 100644
--- a/README
+++ b/README
@@ -14,6 +14,9 @@ For wireless support:
- wpa_supplicant
- wpa_actiond: for automatic connection
+For bonding support
+- ifenslave
+
For bridge support:
- bridge-utils
diff --git a/docs/examples/tunnel-he-ipv6 b/docs/examples/tunnel-he-ipv6
new file mode 100644
index 0000000..21b4579
--- /dev/null
+++ b/docs/examples/tunnel-he-ipv6
@@ -0,0 +1,11 @@
+CONNECTION='tunnel'
+DESCRIPTION='A example ipv6 tunnel with Hurricane Electric'
+
+INTERFACE='he-ipv6'
+MODE='sit'
+REMOTE='216.66.80.26'
+#LOCAL='172.16.0.1'
+
+IP6='static'
+ADDR6='2001:470:1f08:d87::2/64'
+ROUTES6=('::/0')
diff --git a/docs/netcfg-profiles.txt b/docs/netcfg-profiles.txt
index 615ad6c..5e11076 100644
--- a/docs/netcfg-profiles.txt
+++ b/docs/netcfg-profiles.txt
@@ -46,6 +46,8 @@ bridge
: Network bridge setup using **brctl**(8).
tuntap
: TUN/TAP interfaces.
+tunnel
+: Tunnel interfaces.
vlan
: VLAN setup.
openvpn
@@ -241,6 +243,20 @@ VLAN_PHYS_DEV
VLAN_ID
: See **ip**(8).
+Options for 'tunnel' connections
+================================
+
+Standard 'ethernet' options apply for IP configuration.
+
+INTERFACE
+: The name of the tunnel interface.
+MODE
+: The tunnel type (e.g. 'sit'). See **ip**(8) for available modes.
+LOCAL
+: The address of the local end of the tunnel.
+REMOTE
+: The address of the remote end of the tunnel.
+
Options for 'openvpn' connections
================================
diff --git a/src/connections/bond b/src/connections/bond
new file mode 100644
index 0000000..6ba463e
--- /dev/null
+++ b/src/connections/bond
@@ -0,0 +1,49 @@
+#! /bin/bash
+. /usr/lib/network/network
+IFENSLAVE="/sbin/ifenslave"
+
+bond_up() {
+ load_profile "$1"
+
+ if [ -e /sys/class/net/$INTERFACE ]; then
+ report_fail "Interface $INTERFACE already exists."
+ exit 1
+ else
+ ip link add dev $INTERFACE type bond
+ fi
+ bring_interface up "$INTERFACE"
+ "$CONN_DIR/ethernet" up "$1"
+
+ for slave in ${SLAVE_INTERFACES[@]}; do
+ bring_interface up "$INTERFACE"
+ $IFENSLAVE $INTERFACE $slave
+ done
+
+ return 0
+}
+
+bond_down() {
+ load_profile "$1"
+
+ for slave in ${SLAVE_INTERFACES[@]}; do
+ $IFENSLAVE $INTERFACE -d $slave
+ done
+
+ "$CONN_DIR/ethernet" down "$1"
+ bring_interface down "$INTERFACE"
+ ip link delete $INTERFACE &>/dev/null
+ return 0
+}
+
+bond_status() {
+ if [ -e /sys/class/net/$INTERFACE ]; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+bond_$1 "$2"
+exit $?
+
+# vim: set ts=4 et sw=4:
diff --git a/src/connections/tunnel b/src/connections/tunnel
new file mode 100644
index 0000000..613cc67
--- /dev/null
+++ b/src/connections/tunnel
@@ -0,0 +1,41 @@
+#! /bin/bash
+. /usr/lib/network/network
+
+tunnel_up() {
+ load_profile "$1"
+
+ if [ -e "/sys/class/net/$INTERFACE" ]; then
+ report_fail "Interface $INTERFACE already exists."
+ exit 1
+ else
+ ip tunnel add "$INTERFACE" mode "$MODE" remote "$REMOTE"
+ fi
+
+ if [[ -n "$LOCAL" ]]; then
+ ip tunnel change "$INTERFACE" local "$LOCAL"
+ fi
+
+ bring_interface up "$INTERFACE"
+
+ "$CONN_DIR/ethernet" up "$1"
+ return 0
+}
+
+tunnel_down() {
+ load_profile "$1"
+
+ "$CONN_DIR/ethernet" down "$1"
+ bring_interface down "$INTERFACE"
+ ip tunnel del "$INTERFACE"
+
+ return 0
+}
+
+tunnel_status() {
+ true
+}
+
+tunnel_$1 "$2"
+exit $?
+
+# vim: set ts=4 et sw=4: